/****************************************************************************
 File name:  schedTest.c
 Author:     $Author$
 Date:       Mar 29, 2012
 Class:      
 Assignment: 
 Purpose:    
 RevisionID:  $Id$
 ****************************************************************************/
#define  _GNU_SOURCE 1 // for RUSAGE_THREAD
#include <sys/time.h>
#include <sys/resource.h>

#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <linux/sched.h>
#include <sys/timeb.h>
#include <string.h>

#define NUM_THREADS 5


void displayUsage(struct rusage *sUsage, int label)
{
	char msg[1024];
	msg[0] = '\0';
	
	sprintf(&(msg[strlen (msg)]), "VOL CONT SWI  %ld\n", sUsage->ru_nvcsw);
	sprintf(&(msg[strlen (msg)]), "IVOL CONT SWI %ld\n", sUsage->ru_nivcsw);
	sprintf(&(msg[strlen (msg)]), "----------------------------------------\n\n");
	
	fprintf(stderr, "%s", msg);
}


/* Each thread will begin control in this function */
void *runner (void *param)
{
	int pid = *(int*) param;
	struct rusage sUsage;
	char msgbuffer[4096];

	struct timeb timeB;
	
	int i, k=0;
	
	sched_yield ();
	msgbuffer[0] = '\0';
	
	for(i=0;i<100000000;i++)
	{
		if( i % 10000000 == 0)
		{
			ftime(&timeB);
			sprintf (&(msgbuffer[strlen(msgbuffer)]),"I am a thread %d\t%08d\t\t%04ld.%03d\n",pid, i, timeB.time % 10000, timeB.millitm);
			//sched_yield();
		}
		sched_yield ();
		k += i;
		
	}
	fprintf(stderr, "%s", msgbuffer);
	fprintf (stderr,"DONE I am a thread pid %d\n",pid);
	getrusage(RUSAGE_SELF, &sUsage);
	displayUsage(&sUsage, pid);

	free(param);
	pthread_exit (0);
}


int main (int argc, char *argv[])
{
	int i;
	int *pCount;
	pthread_t tid[NUM_THREADS];
	pthread_attr_t attr;
	struct sched_param param;

	/* get the default attributes */
	pthread_attr_init (&attr);

	pthread_attr_setinheritsched(&attr, PTHREAD_EXPLICIT_SCHED);
	perror("setinheritsched");

	/* set the scheduling algorithm to PROCESS or SYSTEM */
	pthread_attr_setscope(&attr, PTHREAD_SCOPE_SYSTEM);
	perror("setscope");
	/* set the scheduling policy - FIFO, RR, or OTHER */

	if('R' == argv[1][0])
	{
		
		pthread_attr_setschedpolicy(&attr, SCHED_RR);
		param.sched_priority = sched_get_priority_min(SCHED_RR);
		pthread_attr_setschedparam(&attr, &param);
		
	}
	else if('F' == argv[1][0])
	{
		pthread_attr_setschedpolicy(&attr, SCHED_FIFO);
		param.sched_priority = sched_get_priority_min(SCHED_FIFO);
		pthread_attr_setschedparam(&attr, &param);
		
	}
	else if('B' == argv[1][0])
	{
		pthread_attr_setschedpolicy(&attr, SCHED_BATCH);
		
	}
	else if('I' == argv[1][0])
	{
		pthread_attr_setschedpolicy(&attr, SCHED_IDLE);
	}
	else
	{
		pthread_attr_setschedpolicy(&attr, SCHED_OTHER);
	}
	perror("setschedpolicy");
	//
	


	/* create the threads */
	for (i = 0; i < NUM_THREADS;i++)
	{
		pCount = (int*) malloc(sizeof(int));
		*pCount = i;
		pthread_create(&tid[i], &attr, runner, pCount);
	}

	/* now join on each thread */
	for (i = 0; i < NUM_THREADS; i++)
	{
		pthread_join(tid[i], NULL);
	}

	return EXIT_SUCCESS;
}


