/****************************************************************************
 File name:  schedTest.c
 Author:     $Author$
 Date:       Mar 29, 2012
 Class:      
 Assignment: 
 Purpose:    
 RevisionID:  $Id$
 ****************************************************************************/
#define  _GNU_SOURCE 1 // for RUSAGE_THREAD
#include <sys/time.h>
#include <sys/resource.h>

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sched.h>
#include <linux/sched.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <time.h>
#include <sys/timeb.h>
#include <locale.h>
#include <string.h>


//#define NUM_THREADS 1

void displayUsage(struct rusage *sUsage, int label)
{
	char msg[1024];
	msg[0] = '\0';
	setlocale(LC_NUMERIC, "");
	sprintf(&(msg[strlen (msg)]), "VOL CONT SWI  %'ld\n", sUsage->ru_nvcsw);
	sprintf(&(msg[strlen (msg)]), "IVOL CONT SWI %'ld\n", sUsage->ru_nivcsw);
	sprintf(&(msg[strlen (msg)]), "----------------------------------------\n\n");
	
	fprintf(stderr, "%s", msg);
}

/* Each thread will begin control in this function */
void runner (int pid, int prio)
{
	struct rusage sUsage;
	char msgbuffer[4096];

	struct timeb timeB;
	
	int i, k=0;
	
	sched_yield ();
	msgbuffer[0] = '\0';
	
	for(i=0;i<100000000;i++)
	{
		if( i % 10000000 == 0)
		{
			ftime(&timeB);
			sprintf (&(msgbuffer[strlen(msgbuffer)]),"I am a thread %d\t%08d\t\t%04ld.%03d\n",pid, i, timeB.time % 10000, timeB.millitm);
			//sched_yield();
		}
		sched_yield ();
		k += i;
		
	}
	fprintf(stderr, "%s", msgbuffer);
	fprintf (stderr,"DONE I am a thread pid %d\tpriority %d\n",pid,  prio);
	getrusage(RUSAGE_SELF, &sUsage);
	displayUsage(&sUsage, pid);


}


int main (int argc, char *argv[])
{
	int i;
	int retVal;
	int priority = atoi(argv[2]);
	int NUM_THREADS = atoi(argv[3]);
	pid_t tid[NUM_THREADS];
	struct sched_param sSchedParam;


	sSchedParam.__sched_priority = 99;
	retVal = sched_setscheduler (0, SCHED_FIFO | SCHED_RESET_ON_FORK,
			&sSchedParam);
			
	for(i=0;i<NUM_THREADS;i++)
	{

		tid[i] = fork();
		if(0 == tid[i])
		{
			
			if ('R' == argv[1][0])
			{
				sSchedParam.__sched_priority = (i % priority) + 1;
				retVal = sched_setscheduler (0, SCHED_RR, &sSchedParam);
			}
			else if ('F' == argv[1][0])
			{
				sSchedParam.__sched_priority = (i % priority) + 1;
				retVal = sched_setscheduler (0, SCHED_FIFO, &sSchedParam);
			}
			else if ('B' == argv[1][0])
			{
				sSchedParam.__sched_priority = 0;
				retVal = sched_setscheduler (0, SCHED_BATCH, &sSchedParam);
			}
			else if ('I' == argv[1][0])
			{
				sSchedParam.__sched_priority = 0;
				retVal = sched_setscheduler (0, SCHED_IDLE, &sSchedParam);
			}
			else
			{
				sSchedParam.__sched_priority = 0;
				retVal = sched_setscheduler (0, SCHED_OTHER, &sSchedParam);
			}
			if( retVal == -1)
			{
				perror ("sched_setscheduler");
			}

			// sleep is necessary for all processes to start at about
			// the same time.
			//sleep(2);
			runner(i, (i % priority) + 1);


			// be sure we break out of the loop!
			i = NUM_THREADS+1;
		}
	}

	/* now join on each thread */
	for (i = 0; i < NUM_THREADS; i++)
	{
		waitpid(tid[i],NULL ,0);
	}

	return EXIT_SUCCESS;
}


