/****************************************************************************
 File name:  schedTest.c
 Author:     $Author$
 Date:       Mar 29, 2012
 Class:      
 Assignment: 
 Purpose:    
 RevisionID:  $Id$
 ****************************************************************************/

// http://gcc.gnu.org/ml/fortran/2005-10/msg00365.html
// RUSAGE_THREAD still gives an error in Eclipse.  I think Eclipse does
// not propertly resolve the #define
#define  _GNU_SOURCE 1 // for RUSAGE_THREAD
#include <sys/time.h>
#include <sys/resource.h>

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sched.h>
#include <linux/sched.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <string.h>
#include <time.h>
#include <string.h>




#define NUM_THREADS 10


void displayUsage(struct rusage *sUsage, int label, char* msg)
{
	sprintf(&(msg[strlen (msg)]), "\n");
	sprintf(&(msg[strlen (msg)]), "VOL CONT SWI  %ld\n", sUsage->ru_nvcsw);
	sprintf(&(msg[strlen (msg)]), "IVOL CONT SWI %ld\n", sUsage->ru_nivcsw);
	sprintf(&(msg[strlen (msg)]), "----------------------------------------\n\n");
}


/* Each thread will begin control in this function */
void runner (int pid, char sched, int priority, int bManyFprintf)
{
	int i, k = 0;
	struct rusage sUsage;
	char msg[2048];
	
	msg[0] = '\0';

	for (i = 0; i < 100; i++)
	{
		k += i;
		sched_yield ();
		//nanosleep(&waitTime, &remTime);

	}

	if (1 == bManyFprintf)
	{
		fprintf ( stderr, "I am a thread %3d\t%c\t", pid, sched);
	}
	else
	{
		sprintf (msg, "I am a thread %3d\t%c\t", pid, sched);
	}
	if (sched == 'F')
	{

		if (1 == bManyFprintf)
		{
			fprintf (stderr, "\t");
		}
		else
		{
			sprintf (&(msg[strlen (msg)]), "\t");
		}

	}
	if (0 == priority)
	{

		if (1 == bManyFprintf)
		{
			fprintf (stderr, "\t\t");
			fflush(stderr);
		}
		else
		{
			sprintf (&(msg[strlen (msg)]), "\t\t");
		}

	}

	if (1 == bManyFprintf)
	{
		fprintf (stderr, "%3d\n", priority);
		fflush(stderr);
	}
	else
	{
		sprintf (&(msg[strlen (msg)]), "%3d", priority);
	}

	getrusage(RUSAGE_SELF, &sUsage);
	displayUsage(&sUsage, pid, msg);
	fprintf (stderr, "%s\n", msg);
}

int main (int argc, char *argv[])
{
	int i;
	int retVal;
	char sched;
	int priority = atoi(argv[2]);
	int start = atoi (argv[1]);
	int current;
	int bManyFprintf = 0;

	if (4 == argc)
	{
		bManyFprintf = 1;
	}
	pid_t tid[NUM_THREADS];
	struct sched_param sSchedParam;

	sSchedParam.__sched_priority = 99;
	retVal = sched_setscheduler (0, SCHED_FIFO | SCHED_RESET_ON_FORK,
			&sSchedParam);

	for (i = 0; i < NUM_THREADS; i++)
	{
		current = start % 5;
		start++;

		tid[i] = fork ();
		if (0 == tid[i])
		{
			switch (current)
			{
				case 0:
					sSchedParam.__sched_priority = (i % priority) + 1;
					retVal = sched_setscheduler (0, SCHED_RR, &sSchedParam);
					sched = 'R';
					break;
				case 1:
					sSchedParam.__sched_priority = (i % priority) + 1;
					retVal = sched_setscheduler (0, SCHED_FIFO, &sSchedParam);
					sched = 'F';
					break;
				case 2:
					sSchedParam.__sched_priority = 0;
					retVal = sched_setscheduler (0, SCHED_BATCH, &sSchedParam);
					sched = 'B';
					break;
				case 3:
					sSchedParam.__sched_priority = 0;
					retVal = sched_setscheduler (0, SCHED_IDLE, &sSchedParam);
					sched = 'I';
					break;
				case 4:
					sSchedParam.__sched_priority = 0;
					retVal = sched_setscheduler (0, SCHED_OTHER, &sSchedParam);
					sched = 'O';
					break;
			}
			sleep (3);
			if (retVal == -1)
			{
				char msg[1024];
				msg[0] = '\0';
				strcat (msg, "sched_setscheduler ");
				strncat (msg, &sched, 1);
				perror (msg);
			}
			runner (i, sched, sSchedParam.__sched_priority, bManyFprintf);

			// be sure we break out of the loop!
			i = NUM_THREADS + 1;
		}
	}

	/* now join on each thread */
	for (i = 0; i < NUM_THREADS; i++)
	{
		waitpid (tid[i], NULL, 0);
	}

	return EXIT_SUCCESS;
}

